/*
 * FractalMusicApplet.java
 *
 * Written by John Waymouth as part of the Fractals and Art IQP by John 
 * Waymouth and Steve Conte.
 *
 * Fractals and Art: Music and Fractals
 *
 * This class is a simple interface to the three fractal music examples, which
 * may be run as an applet from a web browser.  This code just implements a 
 * minimal interface, and is not pertinent to the study of fractals and music, 
 * so readers may skip this file.
 *
 */

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class FractalMusicApplet extends JApplet implements ActionListener {
    private JTextField durationBtn;
    private JButton noteGeneratorBtn,multiNoteGeneratorBtn,chordGeneratorBtn;
    private IteratedFunction func=new RandomFunction(System.currentTimeMillis());
    private FractalChordGenerator fcg=new FractalChordGenerator(48,500,func);
    private FractalNoteGenerator fng=new FractalNoteGenerator(48,72,500,func);
    private FractalMultipleNoteGenerator fmng=
	    new FractalMultipleNoteGenerator(60,72,500,func);



    public void init() {
	Container contentPane=getContentPane();
	contentPane.setLayout(new FlowLayout());
	
	JLabel durationLabel=new JLabel("Enter duration in seconds:");
	durationBtn=new JTextField("20",10);
	contentPane.add(durationLabel);
	contentPane.add(durationBtn);

	noteGeneratorBtn=new JButton("FractalNoteGenerator");
	noteGeneratorBtn.addActionListener(this);
	contentPane.add(noteGeneratorBtn);

	multiNoteGeneratorBtn=new JButton("FractalMultipleNoteGenerator");
	multiNoteGeneratorBtn.addActionListener(this);
	contentPane.add(multiNoteGeneratorBtn);

	chordGeneratorBtn=new JButton("FractalChordGenerator");
	chordGeneratorBtn.addActionListener(this);
	contentPane.add(chordGeneratorBtn);
    }

    public void actionPerformed(ActionEvent e) {
	if (e.getActionCommand().equals("FractalNoteGenerator")) {
	    enableButtons(false);	
	    fng.generate(Integer.parseInt(durationBtn.getText())*1000);
	    enableButtons(true);
	} else if (e.getActionCommand().equals("FractalMultipleNoteGenerator")) {
	    enableButtons(false);
	    fmng.generate(Integer.parseInt(durationBtn.getText())*1000);
	    enableButtons(true);
	} else if (e.getActionCommand().equals("FractalChordGenerator")) {
	    enableButtons(false);
	    fcg.generate(Integer.parseInt(durationBtn.getText())*1000);
	    enableButtons(true);
	}
    }
    
    public void enableButtons(boolean enable) {
	noteGeneratorBtn.setEnabled(enable);
	multiNoteGeneratorBtn.setEnabled(enable);
	chordGeneratorBtn.setEnabled(enable);
    }
}
