/** 
 * IteratedFunction.java
 *
 * Written by John Waymouth as part of the Fractals and Art IQP by John 
 * Waymouth and Steve Conte.
 *
 * Fractals and Art: Music and Fractals
 *
 * This interface is for objects that provide numbers through some kind of
 * chaos function.  The nextValue() method mimics the behavior of f(x):
 *
 * x_new=f(x_old)
 *
 * The implementing object rememebers x_old.  The initial x value should be
 * passed in through the constructor or by other means.
 */

public interface IteratedFunction {
    /* Return the next number from the chaos function.  Return value should be
     * an integer between 0 and 255 
     */
    public int nextValue();
}
